﻿/*

  The contents of this file are subject to the Mozilla Public License Version
  1.1 (the "License"); you may not use this file except in compliance with
  the License. You may obtain a copy of the License at

           http://www.mozilla.org/MPL/

  Software distributed under the License is distributed on an "AS IS" basis,
  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
  for the specific language governing rights and limitations under the License.

  The Original Code is AS3 Formation.

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

*/
package 
{
	import voiture.VoiturePublic;
	import flash.events.MouseEvent;
	import nl.demonsters.debugger.MonsterDebugger;
	import flash.text.TextFormat;
	import flash.text.TextField;
	import flash.events.Event;
	import flash.display.Sprite;



	public class Main extends Sprite
	{
		private var debugger:MonsterDebugger;
		private var oTxtSouris:TextField;
		private var oTxtFormat:TextFormat;
		
		
		/**
		 * Constructeur.
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}
		
		
		/**
		 * Démarrage de votre application.
		 * 
		 */
		protected function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);
			
			// Init De MonsterDebugger
			debugger = new MonsterDebugger(this);
			
			// message de debug
			MonsterDebugger.trace(this, "Start Application");
			
			// le code de notre application
			oTxtSouris = new TextField();
			oTxtSouris.autoSize = 'center';
			oTxtSouris.x = 350;
			oTxtSouris.y = 10;
			oTxtSouris.width = stage.stageWidth - oTxtSouris.x;
			
			oTxtFormat = new TextFormat();
			oTxtFormat.font = "Arial";
			oTxtFormat.bold = true;
			oTxtFormat.size = 15;
			oTxtFormat.color = Math.random() * 0X00FFFFFF;
			oTxtSouris.defaultTextFormat = oTxtFormat;
			
			addChild( oTxtSouris );
			
			// écoute des évènements diffusés par la souris
			stage.addEventListener(MouseEvent.MOUSE_MOVE, onUpdateTxtSouris);
			
			var oTxtVoiture:TextField = new TextField();
			oTxtVoiture.autoSize = 'center';
			oTxtVoiture.wordWrap = true;
			oTxtVoiture.x = 10;
			oTxtVoiture.y = 10;
			oTxtVoiture.width = (stage.stageWidth - oTxtVoiture.x) /2;
			oTxtVoiture.defaultTextFormat = oTxtFormat;
			addChild( oTxtVoiture );
			
			// création de plusieurs objets voiture
			var oScenic : VoiturePublic = new VoiturePublic("Scénic", "neuf", "monospace", 42000);
			var oClio : VoiturePublic	= new VoiturePublic("Clio 3", "occasion", "citadine", 7500);
			var oAstonMartin : VoiturePublic	= new VoiturePublic("Aston Martin", "neuve", "course", 180000);
			
			
			oTxtVoiture.text = oScenic.getDescription()+"\n\n"+oClio.getDescription()+"\n\n"+oAstonMartin.getDescription();
		}


		/**
		 * Mise à jour des coordonnées de la souris 
		 * suite à la réception de l'évènement MOUSE_MOVE.
		 * 
		 */
		private function onUpdateTxtSouris(event : MouseEvent) : void
		{
			oTxtSouris.text = "Position de la souris : \n";
			oTxtSouris.appendText("x : "+ mouseX);
			oTxtSouris.appendText("\ny : "+ mouseY);
		}
	}
}
